﻿Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.IO
Imports Infragistics.Win
#Region "IconManager class"

' <summary>
' Class which serves bitmaps created from icons embedded as
' resources. The implementation was designed to be somewhat
' portable; however, it is coupled with the naming convention
' of the icon files it uses. The filenames are implied to contain a 
' number which identifies its dimensions; it is also implied
' that the dimensions of the icons are perfect squares, i.e., the width
' and height are the same.
' </summary>
Public Class IconManager
    Implements IDisposable

    Private Shared ReadOnly iconGroupCount As Integer = 8
    Private Shared ReadOnly iconSizeCount As Integer = 3
    Private Shared ReadOnly namespaceName As String = "Sistemas_Gerenciales"
    Private Shared ReadOnly NombreCarpeta As String = "Resources"

    ' <summary>
    ' The base size of the icons generated by this class (16).
    ' </summary>
    Public Const baseSize As Integer = 16

    Private bitmaps As Bitmap(,)

    ' <summary>
    ' Creates a new instance of the <see cref="IconManager"/> class.
    ' </summary>
    Public Sub New()
        MyBase.New()
        ReDim Me.bitmaps(IconManager.iconGroupCount, IconManager.iconSizeCount)
    End Sub

    ' <summary>
    ' Returns the Icon corresponding to the specified IconGroup
    ' at the specified IconSize. Note that the caller is responsible
    ' for maintaining the lifetime of the returned icon, i.e., must
    ' dispose of it when it is no longer needed.
    ' </summary>
    Private Function GetIcon(ByVal iconGroup As IconGroup, ByVal iconSize As IconSize, ByVal NombreIcono As String) As Icon
        Dim dim1 As Integer = iconGroup
        Dim dim2 As Integer = (iconSize / IconManager.baseSize) - 1
        Dim icon As Icon = Nothing

        Dim stream As Stream = New MemoryStream()

        Dim iconSizeValue As Integer = iconSize
        Dim fileSuffix As String = String.Format("{0}.ICO", iconSizeValue)
        Dim resourceName As String = String.Format("{0}.{1}", IconManager.namespaceName, "Calendar48.ICO")

        Return icon

    End Function

    ' <summary>
    ' Returns the Bitmap corresponding to the specified IconGroup
    ' at the specified IconSize. If no icon exists in the associated
    ' form's resources, null is returned.
    ' </summary>
    Public Function GetBitmap(ByVal iconGroup As IconGroup, ByVal iconSize As IconSize, ByVal strNombreImagen As String) As Bitmap
        Dim dim1 As Integer = iconGroup
        Dim dim2 As Integer = (iconSize / IconManager.baseSize) - 1

        If (Me.bitmaps(dim1, dim2) Is Nothing) Then

            Dim icon As Icon = Me.GetIcon(iconGroup, iconSize, strNombreImagen)
            If Not icon Is Nothing Then
                '	Under version 1.x of the .NET framework, the Icon.ToBitmap method
                '	does not properly preserve transparency information; use the DrawUtility's
                '	IconToBitmap method which does handle it correctly, so the icons which
                '	contain transparent and semi-transparent pixels appear correctly.
                Me.bitmaps(dim1, dim2) = DrawUtility.IconToBitmap(icon)

                '   Dispose of the icon since we have converted it to a Bitmap
                icon.Dispose()
            End If

        End If

        Return Me.bitmaps(dim1, dim2)

    End Function

    ' <summary>
    ' Implements the IDisposable interface's Dispose method.
    ' Disposes of all Bitmaps created by this instance and closes
    ' any streams that remain open.
    ' </summary>
    Public Sub Dispose() Implements IDisposable.Dispose

        Dim group As Integer
        Dim size As Integer

        For group = 0 To IconManager.iconGroupCount - 1

            For size = 0 To IconManager.iconSizeCount - 1

                If (Not Me.bitmaps(group, size) Is Nothing) Then

                    Me.bitmaps(group, size).Dispose()
                    Me.bitmaps(group, size) = Nothing
                End If
            Next
        Next
    End Sub

    Public Function ObtenerIcono(ByVal NombreIcono As String) As Bitmap
        Dim NOMBRE_CARPETA_RESOURCE As String
        Dim NombreCompletoIcono As String
        Dim Imagen As Bitmap

        NOMBRE_CARPETA_RESOURCE = "Global.Sistemas_Gerenciales.My.Resources.Resources."
        NombreCompletoIcono = "Global.Sistemas_Gerenciales.My.Resources.Resources." & NombreIcono
        Imagen = CType(NombreCompletoIcono, Object)
        Return Imagen
    End Function
End Class

#End Region

#Region "IconGroup enumeration"
Public Enum IconGroup
    '	Members of this enumeration must have the same name as
    '	the filename of the associated icon, minus the number which
    '	identifies its dimensions; for example, the 'Customers' group
    '	corresponds to the "Customers16.ICO", "Customers32.ICO", and
    '	"Customers48.ICO" icons.
    Calendar
    Customers
    Employees
    Orders
    OrderDetails
    Products
    AppExit
    ViewStyle
End Enum
#End Region

#Region "IconSize enumeration"
Public Enum IconSize
    '	Note that the relative sizes here are tied to the dimensions
    '	of the arrays that contain the bitmaps such that all constants
    '	herein must be integral multiples of the 'Small' value.
    Small = IconManager.baseSize
    Medium = IconManager.baseSize * 2
    Large = IconManager.baseSize * 3
End Enum
#End Region